<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8" />
		<meta http-equiv="X-UA-Compatible" content="IE=edge" />
		<meta name="viewport" content="width=device-width, initial-scale=1.0" />
		<title>Insert user</title>
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
		<style>
			.form {
				max-width: 500px;
				height: 500px;
			}
		</style>
	</head>
	<body>
		<div class="container jumbotron form pt-3 pb-1">
			<div class="row">
				<h1>Thêm User</h1>
			</div>
			<div class="row form-group mt-5">
				<div class="col-sm-5">
					<label>First name</label>
				</div>
				<div class="col-sm-7">
					<input type="text" class="form-control" id="inp-firstname" />
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-5">
					<label>Last name</label>
				</div>
				<div class="col-sm-7">
					<input type="text" class="form-control" id="inp-lastname" />
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-5">
					<label>Subject</label>
				</div>
				<div class="col-sm-7">
					<input type="text" class="form-control" id="inp-subject" />
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-5">
					<label>Country</label>
				</div>
				<div class="col-sm-7">
					<select name="country" id="select-country" class="form-control">
						<option value="VN">Việt Nam</option>
						<option value="USA">USA</option>
						<option value="AUS">Australia</option>
						<option value="CAN">Canada</option>
					</select>
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-5">
					<label>Custumer Type</label>
				</div>
				<div class="col-sm-7">
					<select
						name="customerType"
						id="select-customertype"
						class="form-control"
					>
						<option value="Standard">Standard</option>
						<option value="Gold">Gold</option>
						<option value="Premium">Premium</option>
					</select>
				</div>
			</div>
			<div class="row justify-content-around mt-5">
				<button class="btn btn-success" id="btn-insert">Insert User</button>
				<button class="btn btn-success">Hủy bỏ</button>
			</div>
		</div>
	</body>
	<script>
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

		$('#btn-insert').click(function () {
			var vInsertObj = {
				firstname: '',
				lastname: '',
				subject: '',
				country: '',
				customerType: '',
			};

			getInsertUser(vInsertObj);
			if (validateInsertObj(vInsertObj) === 1) {
				getApiInsert(vInsertObj);
			}
		});

		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		function getInsertUser(paramObj) {
			paramObj.firstname = $('#inp-firstname').val().trim();
			paramObj.lastname = $('#inp-lastname').val().trim();
			paramObj.subject = $('#inp-subject').val().trim();
			paramObj.country = $('#select-country').val();
			paramObj.customerType = $('#select-customertype').val();
			paramObj.registerStatus = $('#select-registerstatus').val();
		}

		function validateInsertObj(paramObj) {
			if (paramObj.firstname === '') {
				alert('Nhập firstname');
			} else if (paramObj.lastname === '') {
				alert('Nhập lastname');
			} else if (paramObj.subject === '') {
				alert('Nhập subject');
			} else if (paramObj.country === '') {
				alert('Chọn country');
			} else if (paramObj.customerType === '') {
				alert('Chọn customerType');
			} else return 1;
		}

		function getApiInsert(paramObj) {
			$.ajax({
				url: 'http://203.171.20.210:8080/crud-api/users/',
				type: 'POST',
				contentType: 'application/json; charset=utf-8',
				data: JSON.stringify(paramObj),
				dataType: 'json', // added data type
				success: function (vUserObj) {
					console.log(vUserObj);
					alert('Cập nhật thành công');
					window.location.href = 'task33.20.html';
				},
				error: function (ajaxContext) {
					alert(ajaxContext.responseText);
				},
			});
		}
	</script>
</html>
